def f_select_half():
    # 参考: https://at274.hatenablog.com/entry/2020/04/14/002124
    from collections import defaultdict
    N = int(input())
    A = [int(i) for i in input().split()]

    # dp[(i, j, flag)]: A の i 番目の要素まで見たとき、j 個の要素を選んでいるときの和の最大値
    # flag == 1 のときは、i 番目の要素を採用したものとする
    # 初めて指した遷移前が影響してほしくないので、この値で初期化
    dp = defaultdict(lambda: -float('inf'))
    dp[(0, 0, 0)] = 0

    for k, a in enumerate(A, 1):
        j = k // 2
        for x in range(j - 1, j + 2):
            dp[(k, x, 0)] = max(dp[(k - 1, x, 0)], dp[k - 1, x, 1])
            # k-1 番目の要素を選んでいないときだけ、k 番目の要素を選べる
            dp[(k, x, 1)] = dp[(k - 1, x - 1, 0)] + a
    return max(dp[(N, N // 2, f)] for f in (0, 1))

print(f_select_half())